DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Charts - Timeline Chart

Timeline charts represent events in chronological order.

https://en.wikipedia.org
Backend API
$(() => { $('#chart').dxChart({ dataSource, rotated: true, barGroupPadding: 0.2, argumentAxis: { categories: ['Royal Houses'], tick: { visible: false, }, }, title: { text: 'The British Monarchy', subtitle: 'An Abbreviated Timeline', }, commonSeriesSettings: { argumentField: 'monarch', type: 'rangeBar', rangeValue1Field: 'start', rangeValue2Field: 'end', ignoreEmptyPoints: true, barOverlapGroup: 'monarchs', minBarSize: 4, }, seriesTemplate: { nameField: 'house', }, animation: { enabled: false, }, legend: { title: 'Royal Houses', verticalAlignment: 'bottom', horizontalAlignment: 'center', }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.3/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="chart"></div> </div> </body> </html>
#chart { height: 440px; }
const dataSource = [ { monarch: 'Anne', start: new Date(1701, 4, 1), end: new Date(1714, 7, 1), house: 'Stuart', }, { monarch: 'George I', start: new Date(1714, 7, 1), house: 'Hanover', end: new Date(1727, 5, 11), }, { monarch: 'George II', start: new Date(1727, 5, 11), house: 'Hanover', end: new Date(1760, 9, 25), }, { monarch: 'George III', start: new Date(1760, 9, 25), house: 'Hanover', end: new Date(1820, 0, 29), }, { monarch: 'George IV', start: new Date(1820, 0, 29), house: 'Hanover', end: new Date(1830, 5, 26), }, { monarch: 'William IV', start: new Date(1830, 5, 26), house: 'Hanover', end: new Date(1837, 5, 20), }, { monarch: 'Victoria', start: new Date(1837, 5, 20), end: new Date(1901, 0, 22), house: 'Hanover', }, { monarch: 'Edward VII', start: new Date(1901, 0, 22), house: 'Saxe-Coburg and Gotha', end: new Date(1910, 4, 6), }, { monarch: 'George V', start: new Date(1910, 4, 6), house: 'Saxe-Coburg and Gotha', end: new Date(1917, 5, 17), }, { monarch: 'George V', start: new Date(1917, 5, 17), house: 'Windsor', end: new Date(1936, 0, 20), }, { monarch: 'Edward VIII', start: new Date(1936, 0, 20), house: 'Windsor', end: new Date(1936, 11, 11), }, { monarch: 'George VI', start: new Date(1936, 11, 11), house: 'Windsor', end: new Date(1952, 1, 6), }, { monarch: 'Elizabeth II', house: 'Windsor', start: new Date(1952, 1, 6), end: new Date(2022, 8, 8), }, { monarch: 'Charles III', house: 'Windsor', start: new Date(2022, 8, 8), end: new Date(), }, { house: 'Stuart', start: new Date(1701, 4, 1), end: new Date(1714, 7, 1), monarch: 'Royal Houses', }, { end: new Date(1901, 0, 22), house: 'Hanover', start: new Date(1714, 7, 1), monarch: 'Royal Houses', }, { start: new Date(1901, 0, 22), end: new Date(1917, 5, 17), house: 'Saxe-Coburg and Gotha', monarch: 'Royal Houses', }, { house: 'Windsor', start: new Date(1917, 5, 17), end: new Date(), monarch: 'Royal Houses', }, ];

The exact timeline chart implementation steps depend on the data source. Below are general recommendations on how to create a timeline chart.  

  • Choose a series type
    Each event is represented by its name and start/end dates. In this case, the series type should have points with one argument and two values, for example, the Range Bar.

  • Bind the series to data
    You can bind the series to data directly or use a series template (depending on the data source). These approaches and their differences are described in the Bind Series to Data article. In this demo, we use a series template.

  • Line up bars
    Specify the barOverlapGroup to arrange bars in a line that displays a combined timeline.

  • Rotate the chart
    A range bar chart's bars are vertical. To make them horizontal, set the rotated property to true.

  • Sort the events chronologically
    Arguments maintain objects' order in the data source. If this order is not chronological, use the axis' categories array to specify the order.

<template>
<DxChart
id="chart"
:data-source="dataSource"
:rotated="true"
:bar-group-padding="0.2"
>
<DxArgumentAxis :categories="categories">
<DxTick :visible="false"/>
</DxArgumentAxis>
<DxTitle
text="The British Monarchy"
subtitle="An Abbreviated Timeline"
/>
<DxCommonSeriesSettings
argument-field="monarch"
type="rangebar"
range-value1-field="start"
range-value2-field="end"
bar-overlap-group="monarchs"
:min-bar-size="4"
/>
<DxSeriesTemplate name-field="house"/>
<DxAnimation :enabled="false"/>
<DxLegend
vertical-alignment="bottom"
horizontal-alignment="center"
>
<DxTitle text="Royal Houses"/>
</DxLegend>
</DxChart>
</template>
<script setup lang="ts">
import {
DxChart,
DxCommonSeriesSettings,
DxArgumentAxis,
DxAnimation,
DxTick,
DxSeriesTemplate,
DxLegend,
DxTitle,
} from 'devextreme-vue/chart';
import dataSource from './data.ts';
const categories = ['Royal Houses'];
</script>
<style>
#chart {
height: 440px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export default [
{
monarch: 'Anne',
start: new Date(1701, 4, 1),
end: new Date(1714, 7, 1),
house: 'Stuart',
},
{
monarch: 'George I',
start: new Date(1714, 7, 1),
house: 'Hanover',
end: new Date(1727, 5, 11),
},
{
monarch: 'George II',
start: new Date(1727, 5, 11),
house: 'Hanover',
end: new Date(1760, 9, 25),
},
{
monarch: 'George III',
start: new Date(1760, 9, 25),
house: 'Hanover',
end: new Date(1820, 0, 29),
},
{
monarch: 'George IV',
start: new Date(1820, 0, 29),
house: 'Hanover',
end: new Date(1830, 5, 26),
},
{
monarch: 'William IV',
start: new Date(1830, 5, 26),
house: 'Hanover',
end: new Date(1837, 5, 20),
},
{
monarch: 'Victoria',
start: new Date(1837, 5, 20),
end: new Date(1901, 0, 22),
house: 'Hanover',
},
{
monarch: 'Edward VII',
start: new Date(1901, 0, 22),
house: 'Saxe-Coburg and Gotha',
end: new Date(1910, 4, 6),
},
{
monarch: 'George V',
start: new Date(1910, 4, 6),
house: 'Saxe-Coburg and Gotha',
end: new Date(1917, 5, 17),
},
{
monarch: 'George V',
start: new Date(1917, 5, 17),
house: 'Windsor',
end: new Date(1936, 0, 20),
},
{
monarch: 'Edward VIII',
start: new Date(1936, 0, 20),
house: 'Windsor',
end: new Date(1936, 11, 11),
},
{
monarch: 'George VI',
start: new Date(1936, 11, 11),
house: 'Windsor',
end: new Date(1952, 1, 6),
},
{
monarch: 'Elizabeth II',
house: 'Windsor',
start: new Date(1952, 1, 6),
end: new Date(2022, 8, 8),
},
{
monarch: 'Charles III',
house: 'Windsor',
start: new Date(2022, 8, 8),
end: new Date(),
},
{
house: 'Stuart',
start: new Date(1701, 4, 1),
end: new Date(1714, 7, 1),
monarch: 'Royal Houses',
},
{
end: new Date(1901, 0, 22),
house: 'Hanover',
start: new Date(1714, 7, 1),
monarch: 'Royal Houses',
},
{
start: new Date(1901, 0, 22),
end: new Date(1917, 5, 17),
house: 'Saxe-Coburg and Gotha',
monarch: 'Royal Houses',
},
{
house: 'Windsor',
start: new Date(1917, 5, 17),
end: new Date(),
monarch: 'Royal Houses',
},
];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>

<dx-chart
id="chart"
[dataSource]="dataSource"
[rotated]="true"
[barGroupPadding]="0.2"
>
<dxo-chart-argument-axis [categories]="['Royal Houses']">
<dxo-chart-tick [visible]="false"></dxo-chart-tick>
</dxo-chart-argument-axis>
<dxo-chart-title
text="The British Monarchy"
subtitle="An Abbreviated Timeline"
></dxo-chart-title>
<dxo-chart-animation [enabled]="false"></dxo-chart-animation>
<dxo-chart-legend verticalAlignment="bottom" horizontalAlignment="center">
<dxo-chart-title text="Royal Houses"></dxo-chart-title>
</dxo-chart-legend>
<dxo-chart-series-template nameField="house"></dxo-chart-series-template>
<dxo-chart-common-series-settings
argumentField="monarch"
type="rangeBar"
rangeValue1Field="start"
rangeValue2Field="end"
barOverlapGroup="monarchs"
[minBarSize]="4"
>
</dxo-chart-common-series-settings>
</dx-chart>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxChartModule } from 'devextreme-angular';
import { Data, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxChartModule,
],
})
export class AppComponent {
dataSource: Data[];
constructor(service: Service) {
this.dataSource = service.getData();
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #chart {
height: 440px;
}
import { Injectable } from '@angular/core';
export class Data {
house: string;
monarch: string;
start: Date;
end: Date;
}
const dataSource = [
{
monarch: 'Anne',
start: new Date(1701, 4, 1),
end: new Date(1714, 7, 1),
house: 'Stuart',
},
{
monarch: 'George I',
start: new Date(1714, 7, 1),
house: 'Hanover',
end: new Date(1727, 5, 11),
},
{
monarch: 'George II',
start: new Date(1727, 5, 11),
house: 'Hanover',
end: new Date(1760, 9, 25),
},
{
monarch: 'George III',
start: new Date(1760, 9, 25),
house: 'Hanover',
end: new Date(1820, 0, 29),
},
{
monarch: 'George IV',
start: new Date(1820, 0, 29),
house: 'Hanover',
end: new Date(1830, 5, 26),
},
{
monarch: 'William IV',
start: new Date(1830, 5, 26),
house: 'Hanover',
end: new Date(1837, 5, 20),
},
{
monarch: 'Victoria',
start: new Date(1837, 5, 20),
end: new Date(1901, 0, 22),
house: 'Hanover',
},
{
monarch: 'Edward VII',
start: new Date(1901, 0, 22),
house: 'Saxe-Coburg and Gotha',
end: new Date(1910, 4, 6),
},
{
monarch: 'George V',
start: new Date(1910, 4, 6),
house: 'Saxe-Coburg and Gotha',
end: new Date(1917, 5, 17),
},
{
monarch: 'George V',
start: new Date(1917, 5, 17),
house: 'Windsor',
end: new Date(1936, 0, 20),
},
{
monarch: 'Edward VIII',
start: new Date(1936, 0, 20),
house: 'Windsor',
end: new Date(1936, 11, 11),
},
{
monarch: 'George VI',
start: new Date(1936, 11, 11),
house: 'Windsor',
end: new Date(1952, 1, 6),
},
{
monarch: 'Elizabeth II',
house: 'Windsor',
start: new Date(1952, 1, 6),
end: new Date(2022, 8, 8),
},
{
monarch: 'Charles III',
house: 'Windsor',
start: new Date(2022, 8, 8),
end: new Date(),
},
{
house: 'Stuart',
start: new Date(1701, 4, 1),
end: new Date(1714, 7, 1),
monarch: 'Royal Houses',
},
{
end: new Date(1901, 0, 22),
house: 'Hanover',
start: new Date(1714, 7, 1),
monarch: 'Royal Houses',
},
{
start: new Date(1901, 0, 22),
end: new Date(1917, 5, 17),
house: 'Saxe-Coburg and Gotha',
monarch: 'Royal Houses',
},
{
house: 'Windsor',
start: new Date(1917, 5, 17),
end: new Date(),
monarch: 'Royal Houses',
},
];
@Injectable()
export class Service {
getData(): Data[] {
return dataSource;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

DevExtreme v25.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

React Charts - Timeline Chart

Timeline charts represent events in chronological order.

https://en.wikipedia.org
Backend API
import React from 'react'; import { Chart, CommonSeriesSettings, Legend, SeriesTemplate, Animation, ArgumentAxis, Tick, Title, } from 'devextreme-react/chart'; import dataSource from './data.ts'; const axisCategories = ['Royal Houses']; function App() { return ( <Chart id="chart" dataSource={dataSource} barGroupPadding={0.2} rotated={true}> <ArgumentAxis categories={axisCategories}> <Tick visible={false} /> </ArgumentAxis> <Title text="The British Monarchy" subtitle="An Abbreviated Timeline" /> <CommonSeriesSettings type="rangebar" argumentField="monarch" rangeValue1Field="start" rangeValue2Field="end" barOverlapGroup="monarch" minBarSize={4} ></CommonSeriesSettings> <Legend verticalAlignment="bottom" horizontalAlignment="center"> <Title text="Royal Houses" /> </Legend> <SeriesTemplate nameField="house" /> <Animation enabled={false} /> </Chart> ); } export default App;
import React from 'react'; import { Chart, CommonSeriesSettings, Legend, SeriesTemplate, Animation, ArgumentAxis, Tick, Title, } from 'devextreme-react/chart'; import dataSource from './data.js'; const axisCategories = ['Royal Houses']; function App() { return ( <Chart id="chart" dataSource={dataSource} barGroupPadding={0.2} rotated={true} > <ArgumentAxis categories={axisCategories}> <Tick visible={false} /> </ArgumentAxis> <Title text="The British Monarchy" subtitle="An Abbreviated Timeline" /> <CommonSeriesSettings type="rangebar" argumentField="monarch" rangeValue1Field="start" rangeValue2Field="end" barOverlapGroup="monarch" minBarSize={4} ></CommonSeriesSettings> <Legend verticalAlignment="bottom" horizontalAlignment="center" > <Title text="Royal Houses" /> </Legend> <SeriesTemplate nameField="house" /> <Animation enabled={false} /> </Chart> ); } export default App;
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.tsx'; ReactDOM.render( <App />, document.getElementById('app'), );
export default [ { monarch: 'Anne', start: new Date(1701, 4, 1), end: new Date(1714, 7, 1), house: 'Stuart', }, { monarch: 'George I', start: new Date(1714, 7, 1), house: 'Hanover', end: new Date(1727, 5, 11), }, { monarch: 'George II', start: new Date(1727, 5, 11), house: 'Hanover', end: new Date(1760, 9, 25), }, { monarch: 'George III', start: new Date(1760, 9, 25), house: 'Hanover', end: new Date(1820, 0, 29), }, { monarch: 'George IV', start: new Date(1820, 0, 29), house: 'Hanover', end: new Date(1830, 5, 26), }, { monarch: 'William IV', start: new Date(1830, 5, 26), house: 'Hanover', end: new Date(1837, 5, 20), }, { monarch: 'Victoria', start: new Date(1837, 5, 20), end: new Date(1901, 0, 22), house: 'Hanover', }, { monarch: 'Edward VII', start: new Date(1901, 0, 22), house: 'Saxe-Coburg and Gotha', end: new Date(1910, 4, 6), }, { monarch: 'George V', start: new Date(1910, 4, 6), house: 'Saxe-Coburg and Gotha', end: new Date(1917, 5, 17), }, { monarch: 'George V', start: new Date(1917, 5, 17), house: 'Windsor', end: new Date(1936, 0, 20), }, { monarch: 'Edward VIII', start: new Date(1936, 0, 20), house: 'Windsor', end: new Date(1936, 11, 11), }, { monarch: 'George VI', start: new Date(1936, 11, 11), house: 'Windsor', end: new Date(1952, 1, 6), }, { monarch: 'Elizabeth II', house: 'Windsor', start: new Date(1952, 1, 6), end: new Date(2022, 8, 8), }, { monarch: 'Charles III', house: 'Windsor', start: new Date(2022, 8, 8), end: new Date(), }, { house: 'Stuart', start: new Date(1701, 4, 1), end: new Date(1714, 7, 1), monarch: 'Royal Houses', }, { end: new Date(1901, 0, 22), house: 'Hanover', start: new Date(1714, 7, 1), monarch: 'Royal Houses', }, { start: new Date(1901, 0, 22), end: new Date(1917, 5, 17), house: 'Saxe-Coburg and Gotha', monarch: 'Royal Houses', }, { house: 'Windsor', start: new Date(1917, 5, 17), end: new Date(), monarch: 'Royal Houses', }, ];
window.exports = window.exports || {}; window.config = { transpiler: 'ts', typescriptOptions: { module: 'system', emitDecoratorMetadata: true, experimentalDecorators: true, jsx: 'react', }, meta: { 'react': { 'esModule': true, }, 'typescript': { 'exports': 'ts', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, 'openai': { 'esModule': true, }, }, paths: { 'npm:': 'https://cdn.jsdelivr.net/npm/', 'bundles:': '../../../../bundles/', 'externals:': '../../../../bundles/externals/', }, defaultExtension: 'js', map: { 'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js', 'typescript': 'npm:typescript@4.2.4/lib/typescript.js', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'react': 'npm:react@17.0.2/umd/react.development.js', 'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js', 'prop-types': 'npm:prop-types/prop-types.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign', 'devextreme': 'npm:devextreme@25.1.5/cjs', 'devextreme-react': 'npm:devextreme-react@25.1.5/cjs', 'devextreme-quill': 'npm:devextreme-quill@1.7.4/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.21/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js', 'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', '@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js', 'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3', // SystemJS plugins 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme': { defaultExtension: 'js', }, 'devextreme-react': { main: 'index.js', }, 'devextreme-react/common': { main: 'index.js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/common/core/events/utils': { main: 'index', }, 'devextreme/localization/messages': { format: 'json', defaultExtension: 'json', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', ], babelOptions: { sourceMaps: false, stage0: true, react: true, }, }; System.config(window.config); // eslint-disable-next-line const useTgzInCSB = ['openai'];
import React from 'react'; import ReactDOM from 'react-dom'; import App from './App.js'; ReactDOM.render(<App />, document.getElementById('app'));
export default [ { monarch: 'Anne', start: new Date(1701, 4, 1), end: new Date(1714, 7, 1), house: 'Stuart', }, { monarch: 'George I', start: new Date(1714, 7, 1), house: 'Hanover', end: new Date(1727, 5, 11), }, { monarch: 'George II', start: new Date(1727, 5, 11), house: 'Hanover', end: new Date(1760, 9, 25), }, { monarch: 'George III', start: new Date(1760, 9, 25), house: 'Hanover', end: new Date(1820, 0, 29), }, { monarch: 'George IV', start: new Date(1820, 0, 29), house: 'Hanover', end: new Date(1830, 5, 26), }, { monarch: 'William IV', start: new Date(1830, 5, 26), house: 'Hanover', end: new Date(1837, 5, 20), }, { monarch: 'Victoria', start: new Date(1837, 5, 20), end: new Date(1901, 0, 22), house: 'Hanover', }, { monarch: 'Edward VII', start: new Date(1901, 0, 22), house: 'Saxe-Coburg and Gotha', end: new Date(1910, 4, 6), }, { monarch: 'George V', start: new Date(1910, 4, 6), house: 'Saxe-Coburg and Gotha', end: new Date(1917, 5, 17), }, { monarch: 'George V', start: new Date(1917, 5, 17), house: 'Windsor', end: new Date(1936, 0, 20), }, { monarch: 'Edward VIII', start: new Date(1936, 0, 20), house: 'Windsor', end: new Date(1936, 11, 11), }, { monarch: 'George VI', start: new Date(1936, 11, 11), house: 'Windsor', end: new Date(1952, 1, 6), }, { monarch: 'Elizabeth II', house: 'Windsor', start: new Date(1952, 1, 6), end: new Date(2022, 8, 8), }, { monarch: 'Charles III', house: 'Windsor', start: new Date(2022, 8, 8), end: new Date(), }, { house: 'Stuart', start: new Date(1701, 4, 1), end: new Date(1714, 7, 1), monarch: 'Royal Houses', }, { end: new Date(1901, 0, 22), house: 'Hanover', start: new Date(1714, 7, 1), monarch: 'Royal Houses', }, { start: new Date(1901, 0, 22), end: new Date(1917, 5, 17), house: 'Saxe-Coburg and Gotha', monarch: 'Royal Houses', }, { house: 'Windsor', start: new Date(1917, 5, 17), end: new Date(), monarch: 'Royal Houses', }, ];
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.5/css/dx.light.css" /> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script> <script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.tsx"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"></div> </div> </body> </html>
#chart { height: 440px; }

The exact timeline chart implementation steps depend on the data source. Below are general recommendations on how to create a timeline chart.  

  • Choose a series type
    Each event is represented by its name and start/end dates. In this case, the series type should have points with one argument and two values, for example, the Range Bar.

  • Bind the series to data
    You can bind the series to data directly or use a series template (depending on the data source). These approaches and their differences are described in the Bind Series to Data article. In this demo, we use a series template.

  • Line up bars
    Specify the barOverlapGroup to arrange bars in a line that displays a combined timeline.

  • Rotate the chart
    A range bar chart's bars are vertical. To make them horizontal, set the rotated property to true.

  • Sort the events chronologically
    Arguments maintain objects' order in the data source. If this order is not chronological, use the axis' categories array to specify the order.